{% load static %}

{% block scripts %}
    <script type="module">
        import * as pdfjsLib from '{% static "shared/vendor/pdf.js-4.0.379/pdf.mjs" %}'
        import * as pdfjsWorker from '{% static "shared/vendor/pdf.js-4.0.379/pdf.worker.mjs" %}'

        pdfjsLib.GlobalWorkerOptions.workerSrc = pdfjsWorker;
    </script>

    <div class="overflow-x-auto">
        <script data-name="inline-pdf" data-url="{{ request.scheme }}://{{ request.get_host }}{{ page.pdf_url }}">
            let interval = setInterval(
                () => {
                    // get elem
                    if (typeof window.pdfjsLib == 'undefined') return;
                    clearInterval(interval);

                    [...document.querySelectorAll("[data-name='inline-pdf']")].forEach(
                        async (script) => {
                            if (!script.dataset.init) {
                                const parentNode = script.parentNode;
                                const docUrl = script.dataset.url;
                                const pdf = await pdfjsLib.getDocument(docUrl).promise;

                                for (let pageNumber = 1; pageNumber <= pdf.numPages; pageNumber++) {
                                    const page = await pdf.getPage(pageNumber);
                                    const viewport = page.getViewport({ scale: 1.5 });

                                    // Prepare canvas using PDF page dimensions
                                    const canvas = document.createElement("canvas");
                                    canvas.setAttribute("aria-hidden", "true");
                                    const context = canvas.getContext("2d");
                                    canvas.height = viewport.height;
                                    canvas.width = viewport.width;
                                    canvas.style.width = "100%"

                                    // Render PDF page into canvas context
                                    await page.render({
                                        canvasContext: context,
                                        viewport: viewport,
                                    });

                                    parentNode.appendChild(canvas);

                                    const loadingElement = document.getElementById("loading")

                                    if (loadingElement !== null) {
                                        document.getElementById("loading").remove();
                                    }
                                }

                                script.dataset.init = true;
                            }
                        }
                    );

            },
            10
        );
        </script>
    </div>

    <div class="text-gray-500 my-6" id="loading">
        Načítání ...
    </div>

    {% if download_link %}
        <div class="flex flex-col md:flex-row lg:flex-col lg:items-end space-y-2 md:space-y-0 md:space-x-2 lg:space-x-0 lg:space-y-2">
            <a href="{{ request.scheme }}://{{ request.get_host }}{{ page.pdf_url }}">
                <button class="btn btn--inline-icon btn--condensed btn--hoveractive btn--grey-500">
                    <div class="btn__body">Odkaz ke stažení PDF</div>
                </button>
            </a>
        </div>
    {% endif %}
{% endblock %}
